--22
CREATE TABLE TB_DEPT_22
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR2(50) NOT NULL
, CONSTRAINT TB_DEPT_22_PK PRIMARY KEY (DEPT_NO)
);

INSERT INTO TB_DEPT_22 (DEPT_NO, DEPT_NM) VALUES ('D001', '데이터팀');
INSERT INTO TB_DEPT_22 (DEPT_NO, DEPT_NM) VALUES ('D002', '자바개발팀');

COMMIT;

CREATE TABLE TB_DEPT_22_TMP AS
SELECT * FROM TB_DEPT_22
;
-----------------------------------------------------------------------------------------------------------
--23
CREATE TABLE TB_EMP_23
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_NO_CHAR    CHAR(4) NOT NULL
, DEPT_NO_VARCHAR2 VARCHAR2(6) NOT NULL
, CONSTRAINT TB_EMP_23_PK PRIMARY KEY (EMP_NO)
)
;

INSERT INTO TB_EMP_23 (EMP_NO, EMP_NM, DEPT_NO_CHAR, DEPT_NO_VARCHAR2 )
VALUES ('E001', '이경오', 'D001', 'D002');

INSERT INTO TB_EMP_23 (EMP_NO, EMP_NM, DEPT_NO_CHAR, DEPT_NO_VARCHAR2 )
VALUES ('E002', '이수지', 'D003', 'D004');

INSERT INTO TB_EMP_23 (EMP_NO, EMP_NM, DEPT_NO_CHAR, DEPT_NO_VARCHAR2 )
VALUES ('E003', '이지선', 'D001', 'D001');

INSERT INTO TB_EMP_23 (EMP_NO, EMP_NM, DEPT_NO_CHAR, DEPT_NO_VARCHAR2 )
VALUES ('E004', '김진영', 'D002', 'D003');

COMMIT;

SELECT DISTINCT DEPT_NO_CHAR
  FROM TB_EMP_23
 WHERE DEPT_NO_CHAR = DEPT_NO_VARCHAR2
;
-----------------------------------------------------------------------------------------------------------
--24
CREATE TABLE TB_DEPT_24
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR2(50)
, CONSTRAINT TB_DEPT_24_PK PRIMARY KEY (DEPT_NO)
);

INSERT INTO TB_DEPT_24 (DEPT_NO, DEPT_NM) VALUES ('D001', '데이터팀');
INSERT INTO TB_DEPT_24 (DEPT_NO, DEPT_NM) VALUES ('D002', '개발팀'  );
COMMIT;

INSERT INTO TB_DEPT_24 (DEPT_NO, DEPT_NM) VALUES ('D003', '영업팀'  );

SAVEPOINT SVPT1;

INSERT INTO TB_DEPT_24 (DEPT_NO, DEPT_NM) VALUES ('D004', '마케팅팀');

SAVEPOINT SVPT2;

ROLLBACK TO SVPT2;

COMMIT;

SELECT COUNT(*) CNT FROM TB_DEPT_24;
-----------------------------------------------------------------------------------------------------------
--25
CREATE TABLE TB_DEPT_25
(
  DEPT_NO_CHAR     CHAR(6)
, DEPT_NO_VARCHAR2 VARCHAR2(6)
, DEPT_NM          VARCHAR2(50)
);

INSERT INTO TB_DEPT_25 (DEPT_NO_CHAR, DEPT_NO_VARCHAR2, DEPT_NM)
             VALUES ('D001', 'D001  ', '데이터팀'); --DEPT_NO_VARCHAR2 뒤에 공백2개

INSERT INTO TB_DEPT_25 (DEPT_NO_CHAR, DEPT_NO_VARCHAR2, DEPT_NM)
             VALUES ('D002', 'D002  ', '개발팀'  ); --DEPT_NO_VARCHAR2 뒤에 공백2개

INSERT INTO TB_DEPT_25 (DEPT_NO_CHAR, DEPT_NO_VARCHAR2, DEPT_NM)
             VALUES ('D003', 'D003'  , '영업팀'  ); --DEPT_NO_VARCHAR2 뒤에 공백0개

INSERT INTO TB_DEPT_25 (DEPT_NO_CHAR, DEPT_NO_VARCHAR2, DEPT_NM)
             VALUES ('D004', 'D004'  , '마케팅팀'); --DEPT_NO_VARCHAR2 뒤에 공백0개

COMMIT;

SELECT DEPT_NO_CHAR, DEPT_NO_VARCHAR2, DEPT_NM
 FROM TB_DEPT_25
WHERE DEPT_NO_CHAR = DEPT_NO_VARCHAR2
ORDER BY DEPT_NO_CHAR
;
-----------------------------------------------------------------------------------------------------------
--26
CREATE TABLE TB_DEPT_26
(
  DEPT_NO_CHAR_4 CHAR(4)
, DEPT_NO_CHAR_6 CHAR(6)
, DEPT_NM VARCHAR2(50)
);

INSERT INTO TB_DEPT_26 (DEPT_NO_CHAR_4, DEPT_NO_CHAR_6, DEPT_NM)
             VALUES ('D001', 'D001  ', '데이터팀'); --DEPT_NO_CHAR_6 뒤에 공백2개
INSERT INTO TB_DEPT_26 (DEPT_NO_CHAR_4, DEPT_NO_CHAR_6, DEPT_NM)
             VALUES ('D002', 'D002  ', '개발팀'  ); --DEPT_NO_CHAR_6 뒤에 공백2개
INSERT INTO TB_DEPT_26 (DEPT_NO_CHAR_4, DEPT_NO_CHAR_6, DEPT_NM)
             VALUES ('D003', 'D003'  , '영업팀'  ); --DEPT_NO_CHAR_6 뒤에 공백0개
INSERT INTO TB_DEPT_26 (DEPT_NO_CHAR_4, DEPT_NO_CHAR_6, DEPT_NM)
             VALUES ('D004', 'D004'  , '마케팅팀'); --DEPT_NO_CHAR_6 뒤에 공백0개

COMMIT;

SELECT DEPT_NO_CHAR_4
     , REPLACE(DEPT_NO_CHAR_6, ' ', '_') AS DEPT_NO_CHAR_6
     , DEPT_NM
 FROM TB_DEPT_26
WHERE DEPT_NO_CHAR_4 = DEPT_NO_CHAR_6
ORDER BY DEPT_NO_CHAR_4;
-----------------------------------------------------------------------------------------------------------
--27
SELECT TO_CHAR(TO_DATE('2020-12-25 00:00:00', 'YYYY-MM-DD HH24:MI:SS')
     - 1/24/60*10/10, 'YYYY-MM-DD HH24:MI:SS') AS VAL
 FROM DUAL;
-----------------------------------------------------------------------------------------------------------
--28
CREATE TABLE TB_DEPT_28
(
  DEPT_NO CHAR(4)
, DEPT_NM VARCHAR2(50) NOT NULL
, CONSTRAINT TB_DEPT_28_PK PRIMARY KEY (DEPT_NO)
)
;

INSERT INTO TB_DEPT_28 (DEPT_NO, DEPT_NM) VALUES ('D001', '데이터팀');
INSERT INTO TB_DEPT_28 (DEPT_NO, DEPT_NM) VALUES ('D002', '자바개발팀');

COMMIT;

 SELECT COUNT(DEPT_NO)
 FROM TB_DEPT_28
 WHERE DEPT_NO = 1001
;
--ORA-01722: 수치가 부적합합니다
-----------------------------------------------------------------------------------------------------------
--29
CREATE TABLE TB_EMP_29
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, CONSTRAINT TB_EMP_29_PK PRIMARY KEY (EMP_NO)
)
;

INSERT INTO TB_EMP_29 (EMP_NO, EMP_NM) VALUES ('E001', '이경오');
INSERT INTO TB_EMP_29 (EMP_NO, EMP_NM) VALUES ('E002', '이수지');

COMMIT;

SELECT CASE WHEN NVL(MAX(EMP_NM), '없음') = '없음' THEN 'N' ELSE 'Y' END AS EMP_NM_YN
  FROM TB_EMP_29
  WHERE EMP_NM = '이지선';
-----------------------------------------------------------------------------------------------------------
--30
CREATE TABLE TB_PLAYER_30
(
  PLAYER_NO CHAR(4)
, PLAYER_NM VARCHAR2(50) NOT NULL
, HEIGHT NUMBER(15, 2) NOT NULL
, WEIGHT NUMBER(15, 2) NOT NULL
, TEAM_NO CHAR(4)
, CONSTRAINT TB_PLAYER_30_PK PRIMARY KEY (PLAYER_NO)
)
;

INSERT INTO TB_PLAYER_30 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P101', '손흥민', '183.22', '77.8', 'T101');
INSERT INTO TB_PLAYER_30 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P102', '황희찬', '177.87', '78.1', 'T102');
INSERT INTO TB_PLAYER_30 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P103', '이강인', '173.24', '63.8', 'T103');
INSERT INTO TB_PLAYER_30 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P104', '박지성', '178.54', '75.2',  NULL );

COMMIT;

SELECT NVL(A.TEAM_NO, '(Null)') AS TEAM_NO
     , MAX(A.HEIGHT) AS MAX_HEIGHT
  FROM TB_PLAYER_30 A
  GROUP BY A.TEAM_NO
;
-----------------------------------------------------------------------------------------------------------
--31
CREATE TABLE TB_PLAYER_31
(
  PLAYER_NO CHAR(4)
, PLAYER_NM VARCHAR2(50) NOT NULL
, HEIGHT NUMBER(15, 2) NOT NULL
, WEIGHT NUMBER(15, 2) NOT NULL
, TEAM_NO CHAR(4)
, CONSTRAINT TB_PLAYER_31_PK PRIMARY KEY (PLAYER_NO)
)
;

INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P101', '손흥민', '180.00', '77.8', 'T101');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P102', '기성용', '182.00', '81.4', 'T101');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P103', '이청용', '178.00', '78.5', 'T101');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P104', '황희찬', '170.00', '78.1', 'T102');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P105', '이승우', '168.00', '66.5', 'T102');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P106', '이재성', '172.00', '68.5', 'T102');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P107', '김신욱', '190.00', '88.2', 'T103');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P108', '박주호', '188.00', '79.3', 'T103');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P109', '이근호', '186.00', '77.5', 'T103');
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P110', '박지성', '178.00', '75.2',  NULL );
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P111', '홍명보', '182.00', '81.5',  NULL );
INSERT INTO TB_PLAYER_31 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P112', '황선홍', '180.00', '82.1',  NULL );
COMMIT;

SELECT NVL(TEAM_NO, '(Null)') AS TEAM_NO
     , AVG(HEIGHT) "평균키"
  FROM TB_PLAYER_31 A
HAVING MIN(HEIGHT) >= 180
GROUP BY TEAM_NO
ORDER BY TEAM_NO
;
-----------------------------------------------------------------------------------------------------------
--32
CREATE TABLE TB_EMP_32
(
  EMP_NO CHAR(4)
, EMP_NM VARCHAR2(50) NOT NULL
, JOB_NM VARCHAR2(50) NULL
, DEPT_NO CHAR(4) NULL
, CONSTRAINT TB_EMP_32_PK PRIMARY KEY (EMP_NO)
)
;

INSERT INTO TB_EMP_32 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO )
VALUES ('E001', '이부장', 'A개발자', 'D001');

INSERT INTO TB_EMP_32 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO )
VALUES ('E002', '이차장', 'B개발자', 'D001');

INSERT INTO TB_EMP_32 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO )
VALUES ('E003', '이과장', 'C개발자', 'D002');

INSERT INTO TB_EMP_32 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO )
VALUES ('E004', '이대리', 'D개발자', 'D002');

INSERT INTO TB_EMP_32 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO )
VALUES ('E005', '이사원', 'E개발자', 'D003');

INSERT INTO TB_EMP_32 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO )
VALUES ('E006', '이수습', 'E개발자',  NULL );

INSERT INTO TB_EMP_32 (EMP_NO, EMP_NM, JOB_NM, DEPT_NO )
VALUES ('E007', '이인턴',   NULL   , 'D003');

COMMIT;

SELECT A.EMP_NO
     , A.EMP_NM
     , NVL(A.JOB_NM, 'ZZZZ') AS JOB_NM
     , NVL(A.DEPT_NO,'ZZZZ') AS DEPT_NO
  FROM TB_EMP_32 A
 ORDER BY A.JOB_NM ASC, A.DEPT_NO DESC
;

-----------------------------------------------------------------------------------------------------------
--33
CREATE TABLE TB_PLAYER_33
(
  PLAYER_NO CHAR(4)
, PLAYER_NM VARCHAR2(50) NOT NULL
, HEIGHT NUMBER(15, 2) NOT NULL
, WEIGHT NUMBER(15, 2) NOT NULL
, TEAM_NO CHAR(4)
, CONSTRAINT TB_PLAYER_33_PK PRIMARY KEY (PLAYER_NO)
)
;

INSERT INTO TB_PLAYER_33 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P101', '손흥민', '180.00', '77.8', 'T101');
INSERT INTO TB_PLAYER_33 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P102', '기성용', '182.00', '81.4', 'T101');
INSERT INTO TB_PLAYER_33 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P103', '이청용', '178.00', '78.5', 'T101');
INSERT INTO TB_PLAYER_33 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P104', '박지성', '178.00', '75.2',  NULL );
INSERT INTO TB_PLAYER_33 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P105', '홍명보', '182.00', '81.5',  NULL );
INSERT INTO TB_PLAYER_33 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P106', '황선홍', '180.00', '82.1',  NULL );

COMMIT;

SELECT NVL(A.TEAM_NO, 'AAAA') AS TEAM_NO
  FROM TB_PLAYER_33 A
ORDER BY 1 ASC
;

SELECT NVL(A.TEAM_NO, 'AAAA') AS TEAM_NO
  FROM TB_PLAYER_33 A
  ORDER BY 1 DESC
;

SELECT NVL(A.TEAM_NO, 'AAAA') AS TEAM_NO
FROM TB_PLAYER_33 A
ORDER BY TEAM_NO ASC
;

SELECT NVL(A.TEAM_NO, 'AAAA') AS TEAM_NO
  FROM TB_PLAYER_33 A
ORDER BY A.TEAM_NO DESC
;
-----------------------------------------------------------------------------------------------------------
--34
CREATE TABLE TB_TEAM_34
(
  TEAM_NO CHAR(4)
, TEAN_NM VARCHAR(50)
, CONSTRAINT TB_TEAM_34_PK PRIMARY KEY (TEAM_NO)
);

INSERT INTO TB_TEAM_34 (TEAM_NO, TEAN_NM ) VALUES ( 'T101', '토트넘홋스퍼');
INSERT INTO TB_TEAM_34 (TEAM_NO, TEAN_NM ) VALUES ( 'T102', 'FC서울');
INSERT INTO TB_TEAM_34 (TEAM_NO, TEAN_NM ) VALUES ( 'T103', '울산현대');
INSERT INTO TB_TEAM_34 (TEAM_NO, TEAN_NM ) VALUES ( 'T104', 'RB라이프치히');

COMMIT;

CREATE TABLE TB_PLAYER_34
(
  PLAYER_NO CHAR(4)
, PLAYER_NM VARCHAR2(50) NOT NULL
, HEIGHT NUMBER(15, 2) NOT NULL
, WEIGHT NUMBER(15, 2) NOT NULL
, TEAM_NO CHAR(4)
, CONSTRAINT TB_PLAYER_34_PK PRIMARY KEY (PLAYER_NO)
)
;

ALTER TABLE TB_PLAYER_34
ADD CONSTRAINTS FK_TB_PLAYER_34_01 FOREIGN KEY (TEAM_NO)
REFERENCES TB_TEAM_34 (TEAM_NO)
;

INSERT INTO TB_PLAYER_34 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P101', '손흥민', '180.00', '77.8', 'T101');
INSERT INTO TB_PLAYER_34 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P102', '기성용', '182.00', '81.4', 'T102');
INSERT INTO TB_PLAYER_34 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P103', '이청용', '178.00', '78.5', 'T103');
INSERT INTO TB_PLAYER_34 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P104', '황희찬', '182.00', '81.5', 'T104');
INSERT INTO TB_PLAYER_34 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P105', '박지성', '178.00', '75.2',  NULL );
INSERT INTO TB_PLAYER_34 (PLAYER_NO, PLAYER_NM, HEIGHT, WEIGHT, TEAM_NO )
     VALUES ('P106', '황선홍', '180.00', '82.1',  NULL );

COMMIT;


SELECT COUNT(B.PLAYER_NO) + COUNT(A.TEAM_NO) AS CNT
  FROM TB_TEAM_34 A
     , TB_PLAYER_34 B
WHERE A.TEAM_NO = B.TEAM_NO;
-----------------------------------------------------------------------------------------------------------
--38
SELECT ABS(CEIL(3.14) + FLOOR(3.14) * SIGN(-3.14)) AS RESULT_VAL
  FROM DUAL
;
-----------------------------------------------------------------------------------------------------------
--39
SELECT NVL(MAX(DUMMY), 'DUMMY') AS RESULT_VAL
  FROM DUAL
 WHERE 1=0
;
-----------------------------------------------------------------------------------------------------------
--41
CREATE TABLE TB_EMP_41
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50)
, MAJOR VARCHAR2(150)
, DEPT_CD CHAR(3)
);

INSERT INTO TB_EMP_41 VALUES ('100001', '이경오', '컴퓨터소프트웨어학', '101');
INSERT INTO TB_EMP_41 VALUES ('100002', '이수지', '데이터사이언스학'  , '101');
INSERT INTO TB_EMP_41 VALUES ('100003', '이지수', '컴퓨터공학'        , '101');
INSERT INTO TB_EMP_41 VALUES ('100004', '김성민', '컴퓨터공학'        , '102');
INSERT INTO TB_EMP_41 VALUES ('100005', '김민선', '데이터사이언스학'  , '102');
INSERT INTO TB_EMP_41 VALUES ('100006', '김선미', '컴퓨터소프트웨어학', '102');
COMMIT;

SELECT * FROM TB_EMP_41;


SELECT A.*
  FROM TB_EMP_41 A
 WHERE
      (     A.MAJOR = '데이터사이언스학'
        AND A.DEPT_CD = '101'
      )
   OR
      (     A.MAJOR = '컴퓨터공학'
        AND A.DEPT_CD = '102'
      )
;

SELECT A.*
  FROM TB_EMP_41 A
 WHERE A.MAJOR IN ('데이터사이언스학', ' 컴퓨터공학')
   AND A.DEPT_CD IN ('101', '102')
;

SELECT A.*
  FROM TB_EMP_41 A
 WHERE (A.MAJOR, A.DEPT_CD) IN (
       ('데이터사이언스학', '101'), ('컴퓨터공학', '102')
                               );

SELECT A.*
  FROM TB_EMP_41 A
 WHERE (A.MAJOR, A.DEPT_CD) NOT IN (
       ('컴퓨터소프트웨어학', '101'), ('컴퓨터소프트웨어학', '102')
                                   );
-----------------------------------------------------------------------------------------------------------
--42
CREATE TABLE TB_EMP_42
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_CD CHAR(3) NULL
, CONSTRAINT TB_EMP_42_PK PRIMARY KEY(EMP_NO)
)
;

INSERT INTO TB_EMP_42 VALUES ('100001', '이경오', '101');
INSERT INTO TB_EMP_42 VALUES ('100002', '김태호', '101');
INSERT INTO TB_EMP_42 VALUES ('100003', '박태훈', '102');
INSERT INTO TB_EMP_42 VALUES ('100004', '김수지', '102');
INSERT INTO TB_EMP_42 VALUES ('100005', '황정식', '103');
INSERT INTO TB_EMP_42 VALUES ('100006', '황태섭', '103');
INSERT INTO TB_EMP_42 VALUES ('100007', '김미선', '104');
INSERT INTO TB_EMP_42 VALUES ('100008', '박수경', '104');
INSERT INTO TB_EMP_42 VALUES ('100009', '최태경',  NULL);
INSERT INTO TB_EMP_42 VALUES ('100010', '김승리',  NULL);

COMMIT;

SELECT COUNT(DEPT_CD)
     , COUNT(*)
     , COUNT(DISTINCT DEPT_CD)
  FROM TB_EMP_42
;
-----------------------------------------------------------------------------------------------------------
--45
CREATE TABLE TB_PLAYER_45
(
  PLAYER_ID CHAR(6)
, PLAYER_NM VARCHAR2(50)
, BIRTH_DE CHAR(8)
);

INSERT INTO TB_PLAYER_45 VALUES ('100001', '박찬호', '19730629');
INSERT INTO TB_PLAYER_45 VALUES ('100002', '박찬호', '19950605');
INSERT INTO TB_PLAYER_45 VALUES ('100003', '박지성', '19810225');
INSERT INTO TB_PLAYER_45 VALUES ('100004', '이승우', '19980106');

COMMIT;



SELECT A.PLAYER_NM AS 선수명
  FROM TB_PLAYER_45 A
 WHERE A.BIRTH_DE >= '19800101'
   AND A.BIRTH_DE <= '19891231'
;



SELECT TB_PLAYER_45.PLAYER_NM AS 선수명
   FROM TB_PLAYER_45 TB_PLAYER_45
  WHERE TB_PLAYER_45.BIRTH_DE >= '19800101'
    AND TB_PLAYER_45.BIRTH_DE <= '19891231'
 ;

SELECT TB_PLAYER_45.PLAYER_NM AS 선수명
  FROM TB_PLAYER_45
 WHERE TB_PLAYER_45.BIRTH_DE >= '19800101'
   AND TB_PLAYER_45.BIRTH_DE <= '19891231'
 ;

SELECT A.PLAYER_NM AS 선수명
   FROM TB_PLAYER_45 AS A
  WHERE A.BIRTH_DE >= '19800101'
    AND A.BIRTH_DE <= '19891231'
 ;

-----------------------------------------------------------------------------------------------------------
--47
CREATE TABLE TB_EMP_47
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50)
, MAJOR VARCHAR2(150)
, DEPT_CD CHAR(3)
);

INSERT INTO TB_EMP_47 VALUES ('100001', '이경오', '컴퓨터소프트웨어학', '101');
INSERT INTO TB_EMP_47 VALUES ('100002', '이수지', '데이터사이언스학'  , '101');
INSERT INTO TB_EMP_47 VALUES ('100003', '이지수', '컴퓨터공학'        , '101');
INSERT INTO TB_EMP_47 VALUES ('100004', '김성민', '컴퓨터공학'        , '102');
INSERT INTO TB_EMP_47 VALUES ('100005', '김민선', '데이터사이언스학'  , '102');
INSERT INTO TB_EMP_47 VALUES ('100006', '김선미', '컴퓨터소프트웨어학', '102');

COMMIT;

SELECT A.*
  FROM TB_EMP_47 A
 WHERE A.MAJOR LIKE '데이터_____' --언더바(_)의 개수는 5개임
  AND A.EMP_NM LIKE '이%'
;

SELECT A.*
FROM TB_EMP_47 A
WHERE A.MAJOR LIKE '데이터%_____' --언더바(_)의 개수는 5개임
  AND A.EMP_NM LIKE '이%__' --언더바(_)의 개수는 2개임
;

SELECT A.*
  FROM TB_EMP_47 A
 WHERE A.MAJOR LIKE '데이터_____%' --언더바(_)의 개수는 5개임
   AND A.EMP_NM LIKE '이__%' --언더바(_)의 개수는 2개임
;

SELECT A.*
  FROM TB_EMP_47 A
 WHERE A.MAJOR LIKE '데이터_____' --언더바(_)의 개수는 5개임
   AND A.EMP_NM LIKE '이_____%' --언더바(_)의 개수는 5개임
;
-----------------------------------------------------------------------------------------------------------
--48
SELECT CASE WHEN 1 = 1 THEN 1 ELSE 0 END AS RESULT
  FROM DUAL
;
-----------------------------------------------------------------------------------------------------------
--49
SELECT TO_DATE('20200901'||'120000', 'YYYYMMDDHH24MISS') - 1/24/60 AS RESULT_VAL
  FROM DUAL;
-----------------------------------------------------------------------------------------------------------
--50
CREATE TABLE TB_EMP_50
(
  EMP_NO CHAR(6)
, EMP_NM VARCHAR2(50) NOT NULL
, DEPT_CD CHAR(3) NULL
, CONSTRAINT TB_EMP_50_PK PRIMARY KEY(EMP_NO)
);

INSERT INTO TB_EMP_50 VALUES ('100001', '이경오', '101');
INSERT INTO TB_EMP_50 VALUES ('100002', '김태호', '101');
INSERT INTO TB_EMP_50 VALUES ('100003', '박태훈', '102');
INSERT INTO TB_EMP_50 VALUES ('100004', '김수지', '102');
INSERT INTO TB_EMP_50 VALUES ('100005', '황정식', '103');
INSERT INTO TB_EMP_50 VALUES ('100006', '황태섭', '103');
INSERT INTO TB_EMP_50 VALUES ('100007', '김미선', '104');
INSERT INTO TB_EMP_50 VALUES ('100008', '박수경', '104');
INSERT INTO TB_EMP_50 VALUES ('100009', '최태경',  NULL);
INSERT INTO TB_EMP_50 VALUES ('100010', '김승리',  NULL);

COMMIT;

SELECT NVL(DEPT_CD, '(NULL)') AS DEPT_CD
     , COUNT(DEPT_CD) AS DEPT_CD_CNT
     , COUNT(*) AS CNT
  FROM TB_EMP_50
 GROUP BY DEPT_CD
 ORDER BY TB_EMP_50.DEPT_CD
;
