--표 5-17 단일행 문자형 함수 사용 예시
SELECT LOWER('SQL Developer')
     , UPPER('SQL Developer')
     , ASCII('A')
     , CHR('65')
     , CONCAT('SQL', 'Developer')
     , SUBSTR('SQL Developer', 1, 3)
     , LENGTH('SQL')
     , LTRIM(' SQL')
     , RTRIM('SQL ')
  FROM DUAL
;

--표 5-18 단일행 숫자형 함수 사용 예시
SELECT ABS(-15)
     , SIGN(1)
     , MOD(8,3)
     , CEIL(38.1)
     , FLOOR(38.9)
     , ROUND(38.678, 2)
     , ROUND(38.678, 1)
     , ROUND(38.678, 0)
     , ROUND(38.678, -1)
     , TRUNC(38.678)
     , TRUNC(38.678, 1)
     , TRUNC(38.678, 2)
  FROM DUAL
;

--표 5-19 단일행 함수를 이용한 날짜형 데이터 변환 예시
SELECT SYSDATE
     , EXTRACT(YEAR FROM SYSDATE)
     , EXTRACT(MONTH FROM SYSDATE)
     , EXTRACT(DAY FROM SYSDATE)
     , TO_NUMBER(TO_CHAR(SYSDATE, 'YYYY'))
     , TO_NUMBER(TO_CHAR(SYSDATE, 'MM'))
     , TO_NUMBER(TO_CHAR(SYSDATE, 'DD'))
     , TO_NUMBER(TO_CHAR(SYSDATE, 'HH24'))
     , TO_NUMBER(TO_CHAR(SYSDATE, 'MI'))
     , TO_NUMBER(TO_CHAR(SYSDATE, 'SS'))
     , TO_CHAR(SYSDATE, 'YYYY')
     , TO_CHAR(SYSDATE, 'MM')
     , TO_CHAR(SYSDATE, 'DD')
     , TO_CHAR(SYSDATE, 'HH24')
     , TO_CHAR(SYSDATE, 'MI')
     , TO_CHAR(SYSDATE, 'SS')
  FROM DUAL
;

--표 5-20 날짜형 데이터 연산 예시
SELECT SYSDATE
     , SYSDATE - 1
     , SYSDATE - (1/24)
     , SYSDATE - (1/24/60)
     , SYSDATE - (1/24/60/60)
     , SYSDATE - (1/24/60/60) * 10
     , SYSDATE - (1/24/60/60) * 30
  FROM DUAL
;

--표 5-22 명시적 형변환
SELECT TO_CHAR(SYSDATE, 'YYYY/MM/DD')
     , TO_CHAR(SYSDATE, 'YYYY/MM/DD HH24:MI:SS')
     , TO_CHAR(10.25, '$999,999,999.99')
     , TO_CHAR(12500, 'L999,999,999')
     , TO_NUMBER('100') + TO_NUMBER('100')
     , TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD'), 'YYYYMMDD')
  FROM DUAL
;

--코드 5-64 CASE WHEN문을 이용한 CASE 표현
SELECT CASE WHEN A.INDUTY_CL_SE_CD = 'ICS001'
            THEN '대'
            WHEN A.INDUTY_CL_SE_CD = 'ICS002'
            THEN '중'
            WHEN A.INDUTY_CL_SE_CD = 'ICS003'
            THEN '소'
            ELSE ''
             END AS "업종분류구분명"
  FROM TB_INDUTY_CL_SE A
;

--코드 5-65 DECODE 함수를 이용한 CASE 표현
SELECT DECODE( A.INDUTY_CL_SE_CD
             , 'ICS001'
             , '대'
             , 'ICS002'
             , '중'
             , 'ICS003'
             , '소'
             , '' ) AS "업종분류구분명"
  FROM TB_INDUTY_CL_SE A
;

--코드 5-66 NVL 함수를 이용한 NULL 처리
SELECT A.INDUTY_CL_CD
     , A.INDUTY_CL_NM
     , A.INDUTY_CL_SE_CD
     , NVL(UPPER_INDUTY_CL_CD, '최상위') AS "UPPER_INDUTY_CL_CD"
  FROM TB_INDUTY_CL A
 --상위업종분류코드가 NULL인 것, 상위가 존재 안 하는 것
 WHERE A.UPPER_INDUTY_CL_CD IS NULL
;

--표 5-25 NULL 처리 함수 사용 예시
SELECT NULLIF('SQLD', 'SQLP')
     , NULLIF('SQLD', 'SQLD')
     , NVL(NULLIF('SQLD', 'SQLD'), '같음')
     , COALESCE(NULL, NULL, 'SQLD')
     , COALESCE(NULL, ' SQLP', 'SQLD')
     , COALESCE('SQL', ' SQLP', 'SQLD')
  FROM DUAL
;

