--코드 6-19 UNION 연산
SELECT A.INDUTY_CL_CD AS 업종분류코드 --업종분류코드
  FROM TB_INDUTY_CL A --업종분류
 WHERE A.INDUTY_CL_SE_CD = 'ICS001' --대
   AND A.INDUTY_CL_CD = 'Q' --음식
 UNION
SELECT A.UPPER_INDUTY_CL_CD AS 상위업종분류코드 --상위업종분류코드
  FROM TB_INDUTY_CL A --업종분류
 WHERE INDUTY_CL_SE_CD = 'ICS002' --중
   AND A.INDUTY_CL_CD LIKE 'Q%' --커피점/카페
;

--코드 6-20 UNION ALL 연산
SELECT A.INDUTY_CL_CD AS 업종분류코드 --업종분류코드
  FROM TB_INDUTY_CL A --업종분류
 WHERE A.INDUTY_CL_SE_CD = 'ICS001' --대
   AND A.INDUTY_CL_CD = 'Q' --음식
UNION ALL
SELECT A.UPPER_INDUTY_CL_CD AS 상위업종분류코드 --상위업종분류코드
  FROM TB_INDUTY_CL A --업종분류
 WHERE INDUTY_CL_SE_CD = 'ICS002' --중
   AND A.INDUTY_CL_CD LIKE 'Q%' --커피점/카페
;

--코드 6-21 UNION ALL 연산 및 ORDER BY절의 사용
SELECT A.INDUTY_CL_CD
     , A.INDUTY_CL_NM
  FROM TB_INDUTY_CL A
 WHERE INDUTY_CL_SE_CD = 'ICS002' --중
   AND A.INDUTY_CL_CD LIKE 'N%' --관광/여가/오락
UNION ALL
SELECT B.INDUTY_CL_CD AS 업종분류코드, B.INDUTY_CL_NM AS 업종분류명
  FROM TB_INDUTY_CL B
 WHERE B.INDUTY_CL_SE_CD = 'ICS002' --중
   AND B.INDUTY_CL_CD LIKE 'O%' --숙박
 ORDER BY INDUTY_CL_CD
;

--코드 6-22 INTERSECT 연산
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM ='신도림'
INTERSECT
SELECT B.SUBWAY_STATN_NO
     , B.LN_NM
     , B.STATN_NM
  FROM TB_SUBWAY_STATN B
 WHERE B.LN_NM ='2호선'
ORDER BY SUBWAY_STATN_NO
;

--코드 6-23 INTERSECT 연산과 동일한 결과집합을 도출 ?
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM ='신도림'
   AND A.LN_NM = '2호선'
 ORDER BY SUBWAY_STATN_NO
;

--코드 6-24 INTERSECT 연산과 동일한 결과집합을 도출 ?
SELECT A.SUBWAY_STATN_NO
     , A.LN_NM
     , A.STATN_NM
  FROM TB_SUBWAY_STATN A
 WHERE STATN_NM ='신도림'
   AND EXISTS (SELECT 1
                 FROM TB_SUBWAY_STATN K
                WHERE K.SUBWAY_STATN_NO = A.SUBWAY_STATN_NO
                  AND K.LN_NM = '2호선'
               )
 ORDER BY SUBWAY_STATN_NO
;

--코드 6-25 MINUS 연산
SELECT A.LN_NM --노노선명
  FROM TB_SUBWAY_STATN A
 WHERE A.STATN_NM ='선릉'
MINUS
SELECT B.LN_NM --노선명
  FROM TB_SUBWAY_STATN B
 WHERE B.STATN_NM ='강남'
;

--코드 6-26 MINUS 연산 시 주의점
SELECT '선릉' AS 역명 FROM DUAL
UNION ALL
SELECT '선릉' AS 역명 FROM DUAL
;

--코드 6-27 MINUS 연산 시 주의점
SELECT '선릉' AS 역명 FROM DUAL
UNION ALL
SELECT '선릉' AS 역명 FROM DUAL
MINUS
SELECT '강남' AS 역명 FROM DUAL
;

--코드 6-28 MINUS 연산 시 주의점
SELECT *
  FROM
     (
       SELECT '선릉' AS 역명 FROM DUAL
       UNION ALL
       SELECT '선릉' AS 역명 FROM DUAL
     ) X
 WHERE NOT EXISTS ( SELECT 1
                      FROM
                         (
                           SELECT '강남' AS 역명
                             FROM DUAL
                         ) A
                     WHERE A.역명 = X.역명
                  )
;